package BAOBAB::Evaluation;

# $Id: Evaluation.pm,v 1.4 2010/01/19 11:26:20 rnl14480 Exp $

@ISA = qw(BAOBAB::DataObject);

use strict;
use BAOBAB::DataObject;

our %cache = ();

sub new {
	my $c = shift;
	my %a = @_;

	my $r = {
		precursor => $a{precursor},
		measure   => $a{measure},
		value     => $a{value},
		no_cache  => $a{no_cache}
	};

	bless $r, $c;
	$r = $r->SUPER::new();
	my $p = $r->{precursor};
	my $m = $r->{measure};
	$p = $p->() if ref($p) eq 'CODE';
	$m = $m->() if ref($m) eq 'CODE';
	my $id = $p->id . ":" . $m->id;
	$r->{id} = $id;
	$cache{$id} = $r unless $a{no_cache};
	return $r;
}

sub precursor {
	my $s = shift;
	my $o = $s->{precursor};
	$o = $o->() if ref($o) eq 'CODE';
	return $o;
}

sub measure {
	my $s = shift;
	my $o = $s->{measure};
	$o = $o->() if ref($o) eq 'CODE';
	return $o;
}

sub value {
	my $s = shift;
	my $v = shift;
	if ( defined $v ) {
		$s->{value} = $v;
		$s->dirty;
	}
	return $s->{value};
}

1;

