package BAOBAB::Mature;

# $Id: Mature.pm,v 1.5 2009/09/26 21:40:42 rnl14480 Exp $

@ISA = qw(BAOBAB::DataObject);

use strict;
use BAOBAB::DataObject;

our %cache = ();

sub new {
	my $c = shift;
	my %a = @_;

	my $r = {
		id          => $a{id},
		precursor   => $a{precursor},
		position    => $a{position},
		length      => $a{length},
		designation => $a{designation}
	};

	bless $r, $c;
	$r = $r->SUPER::new();
	$cache{ $r->{id} } = $r if defined $a{id};
	return $r;
}

sub precursor {
	my $s = shift;
	my $o = $s->{precursor};
	$o = $o->() if ref($o) eq 'CODE';
	return $o;
}

sub chromosome { return (shift)->precursor->chromosome; }
sub organism   { return (shift)->precursor->organism; }

sub position {
	my $s = shift;
	my $v = shift;
	if ( defined $v ) {
		$s->{position} = $v;
		$s->dirty;
	}
	return $s->{position};
}

sub length {
	my $s = shift;
	my $v = shift;
	if ( defined $v ) {
		$s->{length} = $v;
		$s->dirty;
	}
	return $s->{length};
}

sub designation {
	my $s = shift;
	my $v = shift;
	if ( defined $v ) {
		$s->{designation} = $v;
		$s->dirty;
	}
	return $s->{designation};
}

sub sequence {
	my $s      = shift;
	my $base   = $s->precursor->sequence;
	my $offset = $s->position;

	return substr( $base, $offset, $s->length );
}

sub structure {
	my $s      = shift;
	my $base   = $s->precursor->structure;
	my $offset = $s->position;

	return substr( $base, $offset, $s->length );
}

1;
