package BAOBAB::Organism;

# $Id: Organism.pm,v 1.3 2009/09/25 15:10:31 rnl14480 Exp $

@ISA = qw(BAOBAB::DataObject);

use strict;
use BAOBAB::DataObject;

our %cache = ();

sub new {
	my $c = shift;
	my %a = @_;

	my $r = {
		id        => $a{id},
		genus     => ucfirst( lc( $a{genus} ) ),
		species   => lc( $a{species} ),
		revision  => $a{revision},
		shortname => $a{shortname},
		no_cache  => $a{no_cache}
	};

	bless $r, $c;
	$r = $r->SUPER::new();
	$cache{ $r->{id} } = $r if defined $a{id} && !$a{no_cache};
	return $r;
}

sub genus     { return (shift)->{genus}; }
sub species   { return (shift)->{species}; }
sub revision  { return (shift)->{revision}; }
sub shortname { return (shift)->{shortname}; }

sub binomial_name {
	my $s = shift;
	return join( " ", ( $s->genus, $s->species ) );
}

1;
