package BAOBAB::Overlap;

# $Id: Overlap.pm,v 1.4 2010/06/17 16:47:03 rnl14480 Exp $

@ISA = qw(BAOBAB::DataObject);

use strict;
use BAOBAB::DataObject;

our %cache = ();

sub new {
	my $c = shift;
	my %a = @_;

	my $r = {
		known     => $a{known},
		candidate => $a{candidate},
		type      => $a{type},
		pc        => $a{pc},
		no_cache  => $a{no_cache}
	};

	bless $r, $c;
	$r = $r->SUPER::new();
	$r->{known}     = $r->{known}->()     if ref( $r->{known} )     eq 'CODE';
	$r->{candidate} = $r->{candidate}->() if ref( $r->{candidate} ) eq 'CODE';
	my $id = $r->{known}->id . ":" . $r->{candidate}->id;
	$r->{id} = $id;
	$cache{$id} = $r unless $a{no_cache};
	return $r;
}

sub known {
	my $s = shift;
	my $o = $s->{known};
	return $o;
}

sub candidate {
	my $s = shift;
	my $o = $s->{candidate};
	return $o;
}

sub type {
	my $s = shift;
	my $v = shift;
	if ( defined $v ) {
		$s->{type} = $v;
		$s->dirty;
	}
	return $s->{type};
}

sub pc {
	my $s = shift;
	my $v = shift;
	if ( defined $v ) {
		$s->{pc} = $v;
		$s->dirty;
	}
	return $s->{pc};
}

1;

