package BAOBAB::SequenceUtils;

# $Id: SequenceUtils.pm,v 1.3 2010/06/17 16:49:20 rnl14480 Exp $

our @NUCLEOTIDES = qw(A T G C);
our %COMPLEMENT = ( A => 'T', T => 'A', C => 'G', G => 'C' );

use Exporter;

#use Compress::LZW;

@ISA    = qw(Exporter);
@EXPORT = qw(&reverse_complement &gc_content &entropy);

#@EXPORT_OK = qw(&lzw_ratio);

use strict;

sub reverse_complement {
	my $s  = shift;
	my $ns = '';

	my @n = split( //, uc($s) );
	foreach my $n (@n) {
		$ns = $COMPLEMENT{$n} . $ns;
	}
	return $ns;
}

sub gc_content {
	my $s = uc(shift);
	my %c;
	$c{$_} = 0 for @NUCLEOTIDES;
	my @n = split( //, $s );
	@n = grep { exists $COMPLEMENT{$_} } @n;
	$c{$_}++ for (@n);

	return ( ( $c{G} + $c{C} ) / scalar(@n) );
}

sub entropy {
	my $s = uc(shift);
	my %c;
	my @n = split( //, $s );
	@n = grep { exists $COMPLEMENT{$_} } @n;
	$c{$_}++ for (@n);
	$c{$_} /= scalar(@n) for keys %c;
	my $e  = 0;
	my $ns = scalar(@NUCLEOTIDES);
	$e -= $c{$_} * log( $c{$_} ) / log($ns) for keys %c;
	return $e;
}

#sub lzw_ratio {
#	my $s = uc(shift);
#	my $i = length($s);
#	my $f = length( compress( $s, 12 ) );
#
#	return $f / $i;
#}

1;
