package BAOBAB::Wrapper;

# $Id: Wrapper.pm,v 1.5 2010/06/17 16:49:20 rnl14480 Exp $

use strict;
use DBI;
use Data::Dumper qw(Dumper);
use Carp;

# These authentication credentials should be changed to your own
our $database = 'miRNA';
our $hostname = 'localhost';
our $port     = '3306';

our $user     = 'root';
our $password = '';
our $objects  = 0;

our $dsn = "DBI:mysql:database=$database;host=$hostname;port=$port";

sub new {
	my $c = shift;
	my $r = {};
	$objects++;

	return bless $r, $c;
}

sub dbh       { return (shift)->{dbh}; }
sub no_update { return (shift)->{no_update}; }

sub connect {
	my $s = shift;

	if ( defined $s->dbh ) {
		return $s->dbh;
	}
	else {
		print STDERR "Connection to the database\n";
		$s->{dbh} =
		  DBI->connect( $dsn, $user, $password,
			{ RaiseError => 1, AutoCommit => 0 } )
		  || die "Could not connect to database : $DBI::errstr\n";

		$s->{dbh}->{mysql_auto_reconnect} = 1;
		return $s->dbh;
	}
}

sub wrap {
	my $s = shift;
	my $v = shift;
	$s->{object} = $v if defined $v;
	return $s->{object};
}

sub is_dirty {
	my $s = shift;

	if ( $s->wrap->can("is_dirty") ) {
		return $s->wrap->is_dirty;
	}
	else {
		return 1;
	}
}

sub clean {
	my $s = shift;
	$s->wrap->clean if $s->wrap->can("clean");
}

sub test {
	my $s = shift;

	my $h   = $s->connect;
	my $sth = $h->prepare(
		qq{
		SELECT id, shortname FROM organism
	}
	) or die $h->errstr;

	$sth->execute or die $sth->errstr;
	while ( my ( $id, $shortname ) = $sth->fetchrow_array ) {
		print STDERR "ID=$id, SHORTNAME=$shortname\n";
	}
}

sub DESTROY {
	my $s = shift;
	--$objects if $objects;
}

1;
